/***************************************************************************
                          ToyProcess.h  -  Defines the Process
    structure.
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca 
***************************************************************************/

#ifndef __TOYPROCESS_H__
#define __TOYPROCESS_H__

#ifdef __cplusplus
  extern "C" {
#endif/*__cplusplus*/

/*! \brief The structure that defines a process. */
/** 
 * Contains a linked list of memory segments, linked list of
 * space holes in the heap segment, a linked list of used space
 * in the heap segment, and a pointer to the current space hole in
 * the free list.
 */
typedef struct Process
{
  int ID;
  /*! \brief Memory segments         */
  struct SegList *segments;
  /*! \brief Head of unused portions of heap */
  struct SegList *freeheap;
  /*! \brief Used portions of heap   */
  struct SegList *usedheap;
  /*! \brief Pointer to previous spot in free list */
  struct SegList *ptr;      
} Process;

#ifdef __cplusplus
  }
#endif/*__cplusplus*/

#endif/*__TOYPROCESS_H__*/
