/***************************************************************************
                          ToySegment.h  -  Defines the ToySegment
    structure.
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca 
***************************************************************************/
#ifndef __TOYSEGMENT_H__
#define __TOYSEGMENT_H__

#ifdef __cplusplus
  extern "C" {
#endif/*__cplusplus*/

/*! \brief Structure that defines a segment. */
typedef struct ToySegment
{
  /*! \brief Position of segment. */  
  int pos;
  /*! \brief Length of segment. */  
  int len;
} ToySegment;

/*! \brief Enumeration describing the ordering of segments - code,data,heap,stack. */
typedef enum SegType_e
{
  /* \brief Invalid segment number */
  SEG_ERROR = -1
  /* \brief Code segment */
, SEG_CODE = 0
  /* \brief Data segment */
, SEG_DATA = 1
  /* \brief Heap segment */
, SEG_HEAP = 2
  /* \brief Stack segment */
, SEG_STACK= 3
} SegType_e;


#ifdef __cplusplus
  }
#endif/*__cplusplus*/

#endif/*__TOYSEGMENT_H__*/
