/***************************************************************************
                          main.c

    Main program that creates and manipulates a Toy Memory Manager.

                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca
***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "ToyMem.h"

/*! \brief The default memory size */
#define MEMORY_SIZE 1000

int main(int argc, char *argv[])
{
  ToyMM *tm=NULL;
  int memsize=MEMORY_SIZE;

  if(argc<2)
  {
    printf("Use commandline parameter 'toymem parse.txt [parse2.txt] ...'\n");
    return(-1);
  }

  tm=TMM_Create(memsize);
  
  if(tm==NULL)
  {
    printf("Couldn't create ToyMM\n");
  }

  if(argc==2) /*  Backwards compatibility - don't print filenames when
                  there's only one parameter                            */
  {
    if(TMM_ParseFile(argv[1],tm)<0)
      printf("---------------Couldn't parse %s-----------------\n",argv[1]);
  }
  else
  {
    int n;
    for(n=1; n<argc; n++)
    {
      printf("---------------Parsing %s------------------------\n",argv[n]);

      if(TMM_ParseFile(argv[n],tm)<0)
        printf("---------------Couldn't parse %s-----------------\n",argv[n]);
      else
        printf("---------------Parsed %s-------------------------\n",argv[n]);
    }
  }

  TMM_Free(tm);

  return EXIT_SUCCESS;
}
